@echo off
REM HEI EDA Launch Script (HELS)
REM Copyright (C) 2015 HES-SO Valais Wallis / HEI

REM This program is free software: you can redistribute it and/or modify
REM it under the terms of the GNU General Public License as published by
REM the Free Software Foundation, either version 3 of the License, or
REM (at your option) any later version.

REM This program is distributed in the hope that it will be useful,
REM but WITHOUT ANY WARRANTY; without even the implied warranty of
REM MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
REM GNU General Public License for more details.

REM You should have received a copy of the GNU General Public License
REM along with this program.  If not, see <http://www.gnu.org/licenses/>.
SETLOCAL EnableExtensions EnableDelayedExpansion
set VERSION=15.0828.kart
echo HEI EDA Launch Script (HELS) v.%VERSION%
echo kart specials: special DESIGN_SCRATCH_DIR;
echo.

REM ----------------------------------------------------------------------------
REM Define environment variables, manual section
REM
set DESIGN_NAME=dcMotorController
set HDS_PROJECT_DIR=%CD%
echo Setting up project %DESIGN_NAME% at %HDS_PROJECT_DIR%
REM set the HDL-Designer project file
set HDS_LIBS=%HDS_PROJECT_DIR%\Prefs\hds.hdp
:: Specifies alternative location for the .cache file directory.
:: if pointed to an unexisting folder, no cache files will be generated
set HDS_CACHE_DIR=%BASE_DIR%\cache
:: Disable usage of .cache.dat
set HDS_TRUST_CACHE=0

REM set and verify tool installation paths
REM first check path as set on my PC, if not found, check official labo14 path
set HDS_HOME=C:\eda\mentor\HDS2009.2
if not exist !HDS_HOME!\ (
	set HDS_HOME=C:\eda\HDS
	if not exist !HDS_HOME!\ (
		echo ERROR: No valid installtion of HDS found: please verify your HDS_HOME settings.
		pause
		exit
	)
)
echo Found HDL-Designer at !HDS_HOME!
set MODELSIM_HOME=C:\eda\modeltech_6.6g
if not exist !MODELSIM_HOME!\ (
	set MODELSIM_HOME=C:\eda\Modelsim
	if not exist !MODELSIM_HOME!\ (
		echo ERROR: No valid installtion of ModelSim found: please verify your MODELSIM_HOME settings.
		pause
		exit
	)
)
echo Found ModelSim     at !MODELSIM_HOME!
set ACTEL_HOME=C:\eda\Microsemi\Libero_v11.0
if not exist !ACTEL_HOME!\ (
	set ACTEL_HOME=C:\eda\Microsemi\Libero_v11.0
	if not exist !ACTEL_HOME!\ (
		echo ERROR: No valid installtion of Libero found: please verify your ACTEL_HOME settings.
		pause
		exit
	)
)
echo Found Libero       at !ACTEL_HOME!
set ISE_HOME=C:\eda\Xilinx\ISE_DS\ISE\bin\nt
if not exist !ISE_HOME!\ (
	set ISE_HOME=C:\eda\Xilinx\14.5\ISE_DS\ISE\bin\nt64
	if not exist !ISE_HOME!\ (
		set ISE_HOME=C:\eda\Xilinx\12.1\ISE_DS\ISE\bin\nt64
		if not exist !ISE_HOME!\ (
			echo ERROR: No valid installtion of ISE found: please verify your ISE_HOME settings.
			pause
			exit
		)
	)
)
echo Found ISE          at !ISE_HOME!

REM set existing library installation paths
set HDS_PRIMS_DIR=HDS_PROJECT_DIR%\..\libs
if not exist !HDS_PRIMS_DIR!\ (
	set HDS_PRIMS_DIR=R:/Modules/SI/2131_ELE/ELN/Labs/Libraries
	if not exist !HDS_PRIMS_DIR!\ (
		echo ERROR: No valid libraries found: please verify your HDS_PRIMS_DIR settings.
		pause
		exit
	)
)
echo Found Prims        at !HDS_PRIMS_DIR!
set HDS_LIBS_DIR=E:/projects/EDA/VHDL/libs
if not exist !HDS_LIBS_DIR!\ (
	set HDS_LIBS_DIR=%HDS_PROJECT_DIR%\..\libs
	if not exist !HDS_LIBS_DIR!\ (
		set HDS_LIBS_DIR=R:/Modules/SI/2131_ELE/ELN/Labs/Libraries
		if not exist !HDS_LIBS_DIR!\ (
			echo ERROR: No valid libraries found: please verify your HDS_LIBS_DIR settings.
			pause
			exit
		)
	)
)
echo Found Libs         at !HDS_LIBS_DIR!
set HDS_LIBRARIES_DIR=%HDS_PROJECT_DIR%\..\libs
if not exist !HDS_LIBRARIES_DIR!\ (
	set HDS_LIBRARIES_DIR=%HDS_PROJECT_DIR%\..\..\libs
	if not exist !HDS_LIBRARIES_DIR!\ (
		set HDS_LIBRARIES_DIR=R:/Modules/SI/2131_ELE/ELN/Labs/Libraries
		if not exist !HDS_LIBRARIES_DIR!\ (
			echo ERROR: No valid libraries found: please verify your HDS_LIBRARIES_DIR settings.
			pause
			exit
		)
	)
)
echo Found Libraries    at !HDS_LIBRARIES_DIR!

REM ----------------------------------------------------------------------------
REM Prepare scratch directory ar C:\temp\eda\<username>\<designname>
REM
ver | findstr /i "5\.1\." > nul
IF %ERRORLEVEL% EQU 0 (
    REM Windows XP and older
    set SCRATCH_DIR=%USERPROFILE:C:\Documents and Settings=C:\temp\EDA%
) else (
    REM Windows Vista and newer
    set SCRATCH_DIR=%USERPROFILE:C:\Users=C:\temp\EDA%
)

set DESIGN_SCRATCH_DIR=%SCRATCH_DIR%\kart\%DESIGN_NAME%

set HDS_LIBS=%HDS_PROJECT_DIR%\Prefs\hds.hdp
set HDS_USER_HOME=%HDS_PROJECT_DIR%\Prefs\hds_user
set HDS_TEAM_HOME=%HDS_PROJECT_DIR%\Prefs\hds_team
set HDS_LIB_BOARD=%HDS_PROJECT_DIR%\board
set HDS_CONCAT_DIR=%HDS_LIB_BOARD%\concat

set SIMULATION_DIR=%HDS_PROJECT_DIR:\=/%/Simulation
echo Found Simulation   at %SIMULATION_DIR%

set ISE_WORK_DIR=Board\ise
set ISE_PROJECT_WORK_DIR=%HDS_PROJECT_DIR%\%ISE_WORK_DIR%
set ISE_SCRATCH_WORK_DIR=%DESIGN_SCRATCH_DIR%\%ISE_WORK_DIR%

set LIBERO_WORK_DIR=Board\libero
set LIBERO_IMPL_DIR=designer\impl1
set LIBERO_SYNT_DIR=synthesis
set LIBERO_PRJX_FILE=%DESIGN_NAME%.prjx
set LIBERO_IDEDES_FILE=FPGA_%DESIGN_NAME%.ide_des
set LIBERO_PROJECT_WORK_DIR=%HDS_PROJECT_DIR%\%LIBERO_WORK_DIR%
set LIBERO_PROJECT_PRJX=%LIBERO_PROJECT_WORK_DIR%\%LIBERO_PRJX_FILE%
set LIBERO_PROJECT_IMPL=%LIBERO_PROJECT_WORK_DIR%\%LIBERO_IMPL_DIR%
set LIBERO_PROJECT_SYNT=%LIBERO_PROJECT_WORK_DIR%\%LIBERO_SYNT_DIR%
set LIBERO_PROJECT_IDEDES_FILE=%LIBERO_PROJECT_IMPL%\%LIBERO_IDEDES_FILE%
set LIBERO_SCRATCH_WORK_DIR=%DESIGN_SCRATCH_DIR%\%LIBERO_WORK_DIR%
set LIBERO_SCRATCH_PRJX=%LIBERO_SCRATCH_WORK_DIR%\%LIBERO_PRJX_FILE%
set LIBERO_SCRATCH_IMPL=%LIBERO_SCRATCH_WORK_DIR%\%LIBERO_IMPL_DIR%
set LIBERO_SCRATCH_SYNT=%LIBERO_SCRATCH_WORK_DIR%\%LIBERO_SYNT_DIR%
set LIBERO_SCRATCH_IDEDES_FILE=%LIBERO_SCRATCH_IMPL%\%LIBERO_IDEDES_FILE%

REM ----------------------------------------------------------------------------
REM Copy files to scratch directory
REM
echo.
echo Copying place and route files to scratch directory: %DESIGN_SCRATCH_DIR%
rmdir /S /Q "%DESIGN_SCRATCH_DIR%"
mkdir "%DESIGN_SCRATCH_DIR%"
REM xcopy /S /I /Y /Q "%ISE_PROJECT_WORK_DIR%" "%ISE_SCRATCH_WORK_DIR%"
xcopy /S /I /Y /Q "%LIBERO_PROJECT_WORK_DIR%" "%LIBERO_SCRATCH_WORK_DIR%"

REM ----------------------------------------------------------------------------
REM Delete intermediate files
REM
echo.
echo Deleting automatically generated files in: %HDS_PROJECT_DIR%
del /s %HDS_PROJECT_DIR%\*.bak %HDS_PROJECT_DIR%\*.lck %HDS_PROJECT_DIR%\.cache.dat
del /s %HDS_PROJECT_DIR%\*_entity.vhd %HDS_PROJECT_DIR%\*_struct.vhd %HDS_PROJECT_DIR%\*_fsm.vhd
del /s %HDS_PROJECT_DIR%\*.vhg

REM ----------------------------------------------------------------------------
REM Launch Application
REM
echo.
echo Launching programs
echo Waiting until programs terminated... WARNING: DO NOT CLOSE THIS WINDOW!
%windir%\system32\cmd.exe /c start /wait !HDS_HOME!\bin\hdldesigner.exe
echo Programs terminated

REM ----------------------------------------------------------------------------
REM Copy files back from the scratch directory
REM
echo.
echo Copying and overwrite place and route files to project directory
xcopy /Y /Q %ISE_SCRATCH_WORK_DIR%\%DESIGN_NAME%.xise %ISE_PROJECT_WORK_DIR%\
xcopy /Y /Q %ISE_SCRATCH_WORK_DIR%\*.bit %ISE_PROJECT_WORK_DIR%\
xcopy /Y /Q %ISE_SCRATCH_WORK_DIR%\*.mcs %ISE_PROJECT_WORK_DIR%\
REM libero project file
REM xcopy /Y /Q %LIBERO_SCRATCH_PRJX% %LIBERO_WORK_DIR%\
REM project database
REM xcopy /Y /Q %LIBERO_SCRATCH_IMPL%\FPGA_%DESIGN_NAME%.adb %LIBERO_PROJECT_IMPL%\
REM programming file
xcopy /Y /Q %LIBERO_SCRATCH_IMPL%\FPGA_%DESIGN_NAME%.pdb %LIBERO_PROJECT_IMPL%\
REM designer file
xcopy /Y /Q %LIBERO_SCRATCH_IDEDES_FILE% %LIBERO_PROJECT_IMPL%\
REM synplify project file
xcopy /Y /Q %LIBERO_SCRATCH_SYNT%\FPGA_%DESIGN_NAME%_syn.prj %LIBERO_PROJECT_SYNT%\
REM netlist
REM xcopy /Y /Q %LIBERO_SCRATCH_SYNT%\FPGA_%DESIGN_NAME%.edn %LIBERO_PROJECT_SYNT%\

REM ----------------------------------------------------------------------------
REM Quit
REM
echo Finished... YOU CAN CLOSE THIS WINDOW NOW!
REM pause
ENDLOCAL

